summaryrefslogtreecommitdiff
path: root/app-doc
diff options
context:
space:
mode:
authorGluzskiy Alexandr <sss123next@list.ru>2016-09-13 10:07:43 +0300
committerGluzskiy Alexandr <sss123next@list.ru>2016-09-13 10:07:43 +0300
commitb8c999c07d679ab34e43a087a9c8fc17f490be29 (patch)
treeb6e92f9d6084737896db8141adbeec932c98c6aa /app-doc
parentaa257bfff7efcac04cd7f7d6d438b7ea668e5c4b (diff)
doxygen: copy from gentoo with disabled libiconv check which is for some reason failed on MY system
Diffstat (limited to 'app-doc')
-rw-r--r--app-doc/doxygen/doxygen-scm.ebuild145
-rw-r--r--app-doc/doxygen/files/doxygen-1.8.11-link_with_pthread.patch32
-rw-r--r--app-doc/doxygen/files/iconv.patch13
-rw-r--r--app-doc/doxygen/metadata.xml19
4 files changed, 209 insertions, 0 deletions
diff --git a/app-doc/doxygen/doxygen-scm.ebuild b/app-doc/doxygen/doxygen-scm.ebuild
new file mode 100644
index 0000000..6f5c8f0
--- /dev/null
+++ b/app-doc/doxygen/doxygen-scm.ebuild
@@ -0,0 +1,145 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+PYTHON_COMPAT=( python{2_7,3_3,3_4,3_5} )
+
+inherit cmake-utils eutils fdo-mime flag-o-matic python-any-r1 git-r3
+EGIT_REPO_URI="git://github.com/doxygen/doxygen.git"
+SRC_URI=""
+KEYWORDS=""
+SRC_URI+=" https://dev.gentoo.org/~xarthisius/distfiles/doxywizard.png"
+
+DESCRIPTION="Documentation system for most programming languages"
+HOMEPAGE="http://www.doxygen.org/"
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="clang debug doc dot doxysearch latex qt5 sqlite userland_GNU"
+
+RDEPEND="app-text/ghostscript-gpl
+ dev-lang/perl
+ media-libs/libpng:0=
+ virtual/libiconv
+ clang? ( sys-devel/clang )
+ dot? (
+ media-gfx/graphviz
+ media-libs/freetype
+ )
+ doxysearch? ( =dev-libs/xapian-1.2* )
+ latex? ( app-text/texlive[extra] )
+ qt5? (
+ dev-qt/qtgui:5
+ dev-qt/qtwidgets:5
+ )
+ sqlite? ( dev-db/sqlite:3 )
+ "
+
+REQUIRED_USE="doc? ( latex )"
+
+DEPEND="sys-apps/sed
+ sys-devel/flex
+ sys-devel/bison
+ doc? ( ${PYTHON_DEPS} )
+ ${RDEPEND}"
+
+# src_test() defaults to make -C testing but there is no such directory (bug #504448)
+RESTRICT="test"
+EPATCH_SUFFIX="patch"
+
+pkg_setup() {
+ use doc && python-any-r1_pkg_setup
+}
+
+src_prepare() {
+ # Ensure we link to -liconv
+ if use elibc_FreeBSD && has_version dev-libs/libiconv || use elibc_uclibc; then
+ for pro in */*.pro.in */*/*.pro.in; do
+ echo "unix:LIBS += -liconv" >> "${pro}"
+ done
+ fi
+
+ # Call dot with -Teps instead of -Tps for EPS generation - bug #282150
+ sed -i -e '/addJob("ps"/ s/"ps"/"eps"/g' src/dot.cpp || die
+
+ epatch "${FILESDIR}"/${PN}-1.8.11-link_with_pthread.patch
+ epatch "${FILESDIR}/iconv.patch"
+
+ # fix pdf doc
+ sed -i.orig -e "s:g_kowal:g kowal:" \
+ doc/maintainers.txt || die
+
+ if is-flagq "-O3" ; then
+ echo
+ ewarn "Compiling with -O3 is known to produce incorrectly"
+ ewarn "optimized code which breaks doxygen."
+ echo
+ elog "Continuing with -O2 instead ..."
+ echo
+ replace-flags "-O3" "-O2"
+ fi
+}
+
+src_configure() {
+ local mycmakeargs=(
+ -DDOC_INSTALL_DIR="share/doc/${P}"
+ $(cmake-utils_use clang use_libclang)
+ $(cmake-utils_use doc build_doc)
+ $(cmake-utils_use doxysearch build_search)
+ $(cmake-utils_use qt5 build_wizard)
+ $(cmake-utils_use sqlite use_sqlite3)
+ )
+
+ cmake-utils_src_configure
+}
+
+src_compile() {
+ cmake-utils_src_compile
+
+ # generate html and pdf documents. errors here are not considered
+ # fatal, hence the ewarn message.
+
+ if use doc; then
+ export VARTEXFONTS="${T}/fonts" # bug #564944
+
+ if ! use dot; then
+ sed -i -e "s/HAVE_DOT = YES/HAVE_DOT = NO/" \
+ {Doxyfile,doc/Doxyfile} \
+ || ewarn "disabling dot failed"
+ fi
+ cd "${BUILD_DIR}" && emake docs
+ fi
+}
+
+src_install() {
+ if use qt5; then
+ doicon "${DISTDIR}/doxywizard.png"
+ make_desktop_entry doxywizard "DoxyWizard ${PV}" \
+ "/usr/share/pixmaps/doxywizard.png" \
+ "Development"
+ fi
+
+ dodoc LANGUAGE.HOWTO README.md
+
+ cmake-utils_src_install
+}
+
+pkg_postinst() {
+ fdo-mime_desktop_database_update
+
+ elog
+ elog "For examples and other goodies, see the source tarball. For some"
+ elog "example output, run doxygen on the doxygen source using the"
+ elog "Doxyfile provided in the top-level source dir."
+ elog
+ elog "Disabling the dot USE flag will remove the GraphViz dependency,"
+ elog "along with Doxygen's ability to generate diagrams in the docs."
+ elog "See the Doxygen homepage for additional helper tools to parse"
+ elog "more languages."
+ elog
+}
+
+pkg_postrm() {
+ fdo-mime_desktop_database_update
+}
diff --git a/app-doc/doxygen/files/doxygen-1.8.11-link_with_pthread.patch b/app-doc/doxygen/files/doxygen-1.8.11-link_with_pthread.patch
new file mode 100644
index 0000000..cdc630c
--- /dev/null
+++ b/app-doc/doxygen/files/doxygen-1.8.11-link_with_pthread.patch
@@ -0,0 +1,32 @@
+diff --git a/addon/doxysearch/CMakeLists.txt b/addon/doxysearch/CMakeLists.txt
+index 33e01c1..165fc3e 100644
+--- a/addon/doxysearch/CMakeLists.txt
++++ b/addon/doxysearch/CMakeLists.txt
+@@ -20,6 +20,7 @@ target_link_libraries(doxyindexer
+ ${ZLIB_LIBRARIES}
+ ${WIN_EXTRA_LIBS}
+ qtools
++ pthread
+ )
+
+ add_executable(doxysearch.cgi
+@@ -29,6 +30,7 @@ target_link_libraries(doxysearch.cgi
+ ${XAPIAN_LIBRARIES}
+ ${ZLIB_LIBRARIES}
+ ${WIN_EXTRA_LIBS}
++ pthread
+ )
+
+ install(TARGETS doxyindexer doxysearch.cgi DESTINATION bin)
+diff --git a/addon/doxywizard/CMakeLists.txt b/addon/doxywizard/CMakeLists.txt
+index bf2eda8..8eb2a1c 100644
+--- a/addon/doxywizard/CMakeLists.txt
++++ b/addon/doxywizard/CMakeLists.txt
+@@ -109,6 +109,7 @@ ${doxywizard_RESOURCES_RCC}
+ qt_use_modules(doxywizard Core Gui Widgets Xml)
+ target_link_libraries(doxywizard
+ ${QT_LIBRARIES} ${QT_QTMAIN_LIBRARY}
++pthread
+ )
+
+ install(TARGETS doxywizard DESTINATION bin)
diff --git a/app-doc/doxygen/files/iconv.patch b/app-doc/doxygen/files/iconv.patch
new file mode 100644
index 0000000..ed46f6e
--- /dev/null
+++ b/app-doc/doxygen/files/iconv.patch
@@ -0,0 +1,13 @@
+diff --git a/cmake/FindIconv.cmake b/cmake/FindIconv.cmake
+index a30f1fd..2fca1f6 100644
+--- a/cmake/FindIconv.cmake
++++ b/cmake/FindIconv.cmake
+@@ -128,8 +128,6 @@ endif()
+
+ if(NOT ICONV_ACCEPTS_CONST_INPUT AND NOT ICONV_ACCEPTS_NONCONST_INPUT)
+ MESSAGE(FATAL_ERROR "Unable to determine iconv() signature")
+-elseif(ICONV_ACCEPTS_CONST_INPUT AND ICONV_ACCEPTS_NONCONST_INPUT)
+- MESSAGE(FATAL_ERROR "Unable to determine iconv() signature - both test cases passed!")
+ endif()
+
+ mark_as_advanced(ICONV_LIBRARY ICONV_INCLUDE_DIR)
diff --git a/app-doc/doxygen/metadata.xml b/app-doc/doxygen/metadata.xml
new file mode 100644
index 0000000..44db0f4
--- /dev/null
+++ b/app-doc/doxygen/metadata.xml
@@ -0,0 +1,19 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+<maintainer type="person">
+ <email>tamiko@gentoo.org</email>
+ <name>Matthias Maier</name>
+</maintainer>
+<longdescription>Doxygen is a tool for analyzing, documenting, and reverse-engineering
+ source code of various languages using a variety of output formats
+ (try it and see). Doxygen supports C++, C, Java, Objective-C, Python,
+ IDL (Corba and Microsoft flavors) and to some extent PHP, C#, and D,
+ as well as other languages (using additional helper tools).
+</longdescription>
+<use>
+ <flag name="clang">support for <pkg>sys-devel/clang</pkg> assisted parsing</flag>
+ <flag name="dot">allow to create dot graphs using <pkg>media-gfx/graphviz</pkg></flag>
+ <flag name="doxysearch">build doxyindexer and doxysearch.cgi</flag>
+</use>
+</pkgmetadata>